/*
 * Dump.cpp
 *
 *  Created on: 28 февр. 2022 г.
 *      Author: User
 */

#include "Dump.h"
#include "UART.h"
#include "string.h"
#include "stdio.h"

extern uart myUART;

void Dump_EEPROM(uint16_t Page, uint8_t BytePerPage, uint16_t CountPage, uint8_t *Buff)
{
  char msg[32] = {0,};
  uint16_t Address = Page * BytePerPage;
  uint16_t Count = CountPage;

  while (Count)
  {
    sprintf(msg, "Page - 0x%04X \n\r", Page);
    myUART.print(msg);
    while(myUART.BytesToWrite()){;}

    for (uint16_t I = 0; I < (BytePerPage/16); I++)
    {
      sprintf(msg, "0x%04X : ", Address);
      myUART.print(msg);
      while(myUART.BytesToWrite()){;}

      for (uint8_t J = 0; J < 16; J++)
      {
        sprintf(msg, "%02X ", *Buff);
        myUART.print(msg);
        while(myUART.BytesToWrite()){;}
        Buff++;
        Address++;
      }
      myUART.println(' ');
      while(myUART.BytesToWrite()){;}
    }
    Page++;
    myUART.println(' ');
    while(myUART.BytesToWrite()){;}
    Count--;
  }
}

/*!
 * Вывод дампа памяти в UART
 * @param Address
 *        Адрес начала дампа
 * @param Count
 *        Количество выводимых байт
 * @param Buff
 *        Ссылка на адрес в памяти с которой начинается вывод
*/

void Dump(uint32_t Address, uint32_t Count, uint8_t *Buff)
{

}
