#include "STM32.h"
#include "DefinesIO.h"
//#include "SButton.h"
#include "HX8347_8bit.h"
#include "IO_Digital.h"
#include "TIM_Base.h"
#include "I2C.h"
#include "STM_BME280.h"


I2C         myI2C(I2C2, false);
S_BME280    myBME;

HX8347  myTFT;                                                                            // Запуливаем дисплей
//IO_Digital  Led_01(GPIOC, GPIO_PIN_13, Output, No_Pull);              //

bool FlagBME = 0;

void myTIM_ISR(void);

int main(void)
{
  int16_t Temp;
  uint8_t Counts = 0;
  uint8_t Buff[256] = {0,};
  char msg[128] = { 0, };

  FLASH_DATAEEPROM_Unlock();                                                              // Разблокирование EEPROM, без этого не работает ничего
  SystemClock_Config(Quartz_8);                                                        // Тактирование, пока без кварца

  myI2C.Init(Mode_Fast);

  /*
   * Сканируем количество и адреса устройств
   */
  myUART.println("Scan Device : ");
  Counts = myI2C.ScanDevice(Buff);
  if(Counts)
  {
    for(uint8_t I=0; I<Counts; I++)
    {
      sprintf(msg, "Device: %d Address - 0x%02X OK \n\r", I, Buff[I]);
      myUART.print(msg);
    }
  }
  sprintf(msg, "\n\rFound - %d Device\n\r", Counts);
  myUART.println(msg);

  /*
   * Инициализация TFT
   */
  myTFT.Init(TFT_DATA_PORT, TFT_DATA_PINS, TFT_RESET_PORT, TFT_RESET_PIN,                 // Самое интересное, что инициализация дисплея
      TFT_CS_PORT, TFT_CS_PIN, TFT_RS_PORT, TFT_RS_PIN, TFT_WR_PORT,                      // содержит в себе функции delay() и здесь
      TFT_WR_PIN, TFT_RD_PORT, TFT_RD_PIN);                                               // они ещё работают
  myTFT.setRotation(1);
  myTFT.fillScreen(COLOR_BLACK);
  //------------ Инициализация TFT ---------------

  // Так просто
  myTFT.setTextColor(COLOR_WHITE, COLOR_BLACK);
  myTFT.setTextSize(2);
  myTFT.println("Hello\n\r");
//  myTFT.fillCircle(120, 120, 50, COLOR_YELLOW);
//  myTFT.fillRect(20, 20, 100, 100, COLOR_GREEN);

  while (1)
  {
//    Led_01.digitalTogglePin();
    delay(1000);
  }
}


/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

