/*
 * RTC.h
 *
 *  Created on: 26 окт. 2021 г.
 *      Author: User
 */

#ifndef INC_RTC_H_
#define INC_RTC_H_

#include <stdint.h> 
#include <cstddef>
#include <STM32.h>

typedef void (*callback_IRQ)(void);

enum{
  RTC_LSI = 0b10,
  RTC_LSE = 0b01,
  RTC_HSE = 0b11
};



class RTC_main
{
  public:
    RTC_main(uint8_t RTC_Tact);
    uint8_t       init(void);
    uint8_t       Reinit(void);
    void          setDate(uint8_t Date, uint8_t Month, uint16_t Year, uint8_t Week);
    void          setTime(uint8_t Hour, uint8_t Minute, uint8_t Sec);
    uint16_t      getYear(void);
    uint8_t       getWeek(void);
    uint8_t       getMonth(void);
    uint8_t       getDate(void);
    uint8_t       getHour(void);
    uint8_t       getMinute(void);
    uint8_t       getSeconds(void);
    callback_IRQ  callback_RTC = NULL;
    void          setIT_WUCK(callback_IRQ ExternIT, uint16_t Timer);

  private:
    static void myISR_WKUP(void);
    uint32_t  _Alarm;
    uint8_t   _Prediv_A;
    uint16_t  _Prediv_S;
    uint8_t   _RTC_FreqSource;
};

#endif /* INC_RTC_H_ */
